<template>
    <div class="wrapper">
        <md-toolbar class="md-dense md-red toolbar-heigth">
            <h3 class="ml-8  md-title text-align-left text-white">
                <md-icon class="text-white">collections</md-icon>
                {{ title }}
            </h3>
        </md-toolbar>
        <loading :active.sync="loading" is-full-page></loading>
        <div class="md-layout md-alignment-top-center">
            <div class="md-layout-item md-size-50 md-small-size-100">
                <md-card>
                    <!-- <md-card-header>
                    <div class="md-title">Nueva colección</div>
                </md-card-header> -->

                    <md-card-content>
                        <md-steppers :md-active-step.sync="active" md-linear>
                            <md-step id="first" :md-label="title" :md-done.sync="first">
                                <form novalidate>
                                    <md-field :class="getValidationClass('label')">
                                        <label>Título</label>
                                        <md-input v-model="form.label" required></md-input>
                                        <span class="md-error">Ingrese un título</span>
                                    </md-field>
                                    <md-field>
                                        <label for="categories">Categoría</label>
                                        <md-select v-model="form.categories" name="categories" id="categories" multiple>
                                            <md-option v-for="item in categories" v-bind:key="item.id" :value="item.id"> {{ item.label }}</md-option>
                                        </md-select>
                                        <!-- <div class="md-error" v-if="!$v.form.categories.required">
                                            Selecciona una categoria.
                                        </div>
                                        <div class="md-error" v-if="!$v.form.categories.maxLength">
                                            Máximo
                                            {{ $v.form.categories.$params.maxLength.max }}
                                            categorías.
                                        </div> -->
                                    </md-field>
                                    <md-field :class="getValidationClass('description')">
                                        <label>Descripción</label>
                                        <md-textarea v-model="form.description" required maxlength="300"></md-textarea>
                                        <span class="md-helper-text">Máximo 300 carácteres</span>
                                        <div class="md-error" v-if="!$v.form.description.required">
                                            Ingrese una descripción.
                                        </div>
                                        <div class="md-error" v-if="!$v.form.description.maxLength">
                                            Máximo
                                            {{ $v.form.description.$params.maxLength.max }}
                                            carácteres.
                                        </div>
                                    </md-field>
                                    <!-- <md-field
                                        :class="getValidationClass('slug')"
                                    >
                                        <label>Etiqueta</label>
                                        <md-select
                                            v-model="form.slug"
                                            required
                                            name="tag"
                                            id="tag"
                                        >
                                            <md-option
                                                v-for="item in tags"
                                                v-bind:key="item.id"
                                                :value="item.slug"
                                            >
                                                {{ item.label }}</md-option
                                            >
                                        </md-select>
                                        <span class="md-error"
                                            >Seleccione una etiqueta</span
                                        >
                                    </md-field> -->
                                </form>
                                <md-button class="md-raised md-primary" @click="validateStep1">{{ title }}</md-button>
                            </md-step>

                            <md-step id="second" md-label="Agregar recursos" :md-error="secondStepError" :md-done.sync="second">
                                <div class="container">
                                    <div class="md-layout md-alignment-top-center">
                                        <div class="md-layout-item md-size-50 md-small-size-100">
                                            <h3>Todos los recursos</h3>

                                            <div class="md-layout">
                                                <div class="md-layout-item md-small-size-100">
                                                    <md-field>
                                                        <!-- <label>Título</label> -->
                                                        <md-input v-model="search" placeholder="Escribe el nombre del recurso" required></md-input>
                                                        <span class="md-error">Ingrese un título</span>
                                                    </md-field>
                                                </div>
                                                <div class="md-layout-item md-size-30 md-small-size-100">
                                                    <md-button class="md-raised md-primary" @click="searchResourcesByCategory">Buscar</md-button>
                                                </div>
                                            </div>
                                            <div class="md-layout md-layout-nowrap">
                                                <div class="md-layout-item md-size-100 md-small-size-100">
                                                    <md-list class="text-break-wrap">
                                                        <md-list-item class="text-break-wrap" v-for="resource in resources" v-bind:key="resource.id">
                                                            <span class="md-list-item-text text-break-wrap">{{ resource.title }}</span>
                                                            <md-button class="md-icon-button md-list-action" @click="AddResource(resource)">
                                                                <md-icon>add_circle</md-icon>
                                                            </md-button>
                                                        </md-list-item>
                                                    </md-list>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="md-layout-item md-size-50 md-small-size-100">
                                            <h3>Recursos de esta colección</h3>
                                            <div class="md-layout md-layout-nowrap">
                                                <div class="md-layout-item md-size-100 md-small-size-100">
                                                    <md-list class="text-break-wrap">
                                                        <md-list-item
                                                            class="text-break-wrap"
                                                            v-for="resource in resourcesAdded"
                                                            v-bind:key="resource.id"
                                                        >
                                                            <span class="md-list-item-text text-break-wrap">{{ resource.title }}</span>
                                                            <md-button class="md-icon-button md-list-action" @click="RemoveResource(resource)">
                                                                <md-icon>remove_circle</md-icon>
                                                            </md-button>
                                                        </md-list-item>
                                                    </md-list>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <md-button class="md-raised md-primary" @click="SaveResourcesToCollection">Guardar</md-button>
                                </div>
                            </md-step>
                        </md-steppers>
                    </md-card-content>

                    <!-- <md-card-actions>
                    <md-button>Action</md-button>
                </md-card-actions> -->
                </md-card>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import { validationMixin } from 'vuelidate';
import { required, minLength, maxLength } from 'vuelidate/lib/validators';

export default {
    name: 'collection',
    mixins: [validationMixin],
    validations: {
        form: {
            label: {
                required,
                minLength: minLength(3)
            },
            description: {
                required,
                minLength: minLength(3),
                maxLength: maxLength(300)
            }
            // categories: {
            //     required,
            //     minLength: minLength(1),
            //     maxLength: maxLength(2)
            // },
            // slug: {
            //     required,
            //     minLength: minLength(3)
            // }
        }
    },
    data() {
        return {
            form: {
                label: null,
                description: null,
                categories: [],
                slug: null,
                resources: []
            },
            endPoint: '/api/collection',
            endPointById: '/api/collectionById',
            categoriesEndPoint: '/api/categories',
            tagsEndPoint: '/api/tagsList',
            resources: [],
            resourcesAdded: [],
            categories: [],
            tags: [],
            showRating: false,
            starSize: 20,
            search: '',
            collection: null,
            collectionId: 0,
            loading: false,

            active: 'first',
            first: false,
            second: false,
            third: false,
            secondStepError: null,
            title: 'Crear colección'
        };
    },
    computed: {
        user() {
            return this.$auth.watch.data;
        }
    },
    methods: {
        getValidationClass(fieldName) {
            const field = this.$v.form[fieldName];

            if (field) {
                return {
                    'md-invalid': field.$invalid && field.$dirty
                };
            }
        },
        validateStep1() {
            this.$v.$touch();

            if (!this.$v.$invalid) {
                this.submitCollection();
            }
        },
        SaveResourcesToCollection() {
            if (this.resourcesAdded && this.resourcesAdded.length > 0) {
                this.form.resources = this.resourcesAdded.map((m) => m.id);
                this.submitCollection();
            } else {
                this.form.resources = [];
                this.$root.WarnMgs('Es necesario agregar un recurso como mínimo.');
            }
        },
        searchResourcesByCategory() {
            let uri = `${this.endPoint}/${this.form.id}?slug=${this.search}`;
            this.loading = true;

            axios
                .get(uri)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        let resources = Object.assign([], res.data.data);

                        if (this.resourcesAdded && this.resourcesAdded.length > 0) {
                            this.resources = resources.filter(this.FilterResourcesById(this.resourcesAdded));
                        } else {
                            this.resources = resources;
                        }
                    } else {
                        this.$root.WarnMgs('No hay resultados');
                        this.resources = null;
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al buscar recursos');
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        FilterResourcesById(otherArray) {
            return function(current) {
                return (
                    otherArray.filter(function(other) {
                        return other.id == current.id;
                    }).length == 0
                );
            };
        },
        AddResource(resource) {
            let currentRes = Object.assign({}, resource);
            this.resources = this.resources.filter(function(el) {
                return el.id != currentRes.id;
            });
            this.resourcesAdded.push(currentRes);
        },
        RemoveResource(resource) {
            let currentRes = Object.assign({}, resource);
            this.resourcesAdded = this.resourcesAdded.filter(function(el) {
                return el.id != currentRes.id;
            });
            this.resources.push(currentRes);
        },
        submitCollection() {
            let data = Object.assign({}, this.form);
            data.categories = JSON.stringify(data.categories);
            data.resources = JSON.stringify(data.resources);
            data.slug = null;
            this.loading = true;

            axios
                .post(this.endPoint, data)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.form.id = res.data.data;
                        this.setDone('first', 'second');
                        this.$root.SuccessMgs('Se ha guardado la colección');
                    } else {
                        this.form.id = 0;
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al Agregar/Actualizar colección');
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getCollectionById() {
            const uri = `${this.endPointById}/${this.collectionId}`;
            this.loading = true;

            axios
                .get(uri)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.form = Object.assign({}, res.data.data);
                        this.resourcesAdded = this.form.resources;
                        this.form.categories = this.form.categories.map((m) => m.id);
                        this.form.resources = this.form.resources.map((m) => m.id);
                        this.updateMessages();
                    } else {
                        this.form = {};
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al obtener colección por Id');
                    console.log('Error getCollectionById' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getCategories() {
            axios
                .get(this.categoriesEndPoint)
                .then((res) => {
                    if (res && res.data && res.data.categories) {
                        this.categories = res.data.categories;
                    } else {
                        this.categories = [];
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al obtener las categorías');
                    console.log('Error GetCategories' + error);
                });
        },
        getTags() {
            axios
                .get(this.tagsEndPoint)
                .then((res) => {
                    if (res && res.data) {
                        this.tags = res.data;
                    } else {
                        this.tags = [];
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al obtener las etiquetas');
                    console.log('Error getTags' + error);
                });
        },
        setDone(id, index) {
            this[id] = true;

            this.secondStepError = null;

            if (index) {
                this.active = index;
            }
        },
        updateMessages() {
            this.title = 'Actualizar colección';
        }
    },
    mounted() {
        this.getCategories();
        // this.getTags();
        this.collectionId = this.$route?.params?.id;

        if (this.collectionId) {
            this.getCollectionById();
        }
    }
};
</script>

<style lang="scss" scoped>
.text-break-wrap {
    word-wrap: break-word !important;
}
</style>
